#
#  AppController.rb
#  Monoalphabetic Substitution Code Converter
#
#  Created by Heiko Kretschmer on 2007/2008.
#  Copyright (c) 2007/2008 Heiko Kretschmer. All rights reserved.
#

require 'osx/cocoa'

# Klasse "AppController"
class AppController < OSX::NSObject

 # Includes
 include OSX

 # Outlets
 ib_outlets :window, :upperTextfield, :lowerTextfield, :splitView, :encodingPopupbutton
 
 # Globals
 $globals = Hash.new
 $globals = { "lastText" => "Wurst-Wasser is good for you!" } # Defaults, bis die Prefs geladen sind
 $globals ["debug"] = 1 # Debug = ENABLED
 #$globals ["debug"] = 0 # Debug = DISABLED


 # Hashtables erstellenfür die Uebersetzung
 $hashtablermirror = Hash.new # http://netzreport.googlepages.com/online_converter_for_rot_5_13_18_47.html
 $hashtablermirror["a"]="z"; $hashtablermirror["A"]="Z"
 $hashtablermirror["b"]="y"; $hashtablermirror["B"]="Y"
 $hashtablermirror["c"]="x"; $hashtablermirror["C"]="X"
 $hashtablermirror["d"]="w"; $hashtablermirror["D"]="W"
 $hashtablermirror["e"]="v"; $hashtablermirror["E"]="V"
 $hashtablermirror["f"]="u"; $hashtablermirror["F"]="U"
 $hashtablermirror["g"]="t"; $hashtablermirror["G"]="T"
 $hashtablermirror["h"]="s"; $hashtablermirror["H"]="S"
 $hashtablermirror["i"]="r"; $hashtablermirror["I"]="R"
 $hashtablermirror["j"]="q"; $hashtablermirror["J"]="Q"
 $hashtablermirror["k"]="p"; $hashtablermirror["K"]="P"
 $hashtablermirror["l"]="o"; $hashtablermirror["L"]="O"
 $hashtablermirror["m"]="n"; $hashtablermirror["M"]="N"
 $hashtablermirror["n"]="m"; $hashtablermirror["N"]="M"
 $hashtablermirror["o"]="n"; $hashtablermirror["O"]="L"
 $hashtablermirror["p"]="m"; $hashtablermirror["P"]="K"
 $hashtablermirror["q"]="j"; $hashtablermirror["Q"]="J"
 $hashtablermirror["r"]="i"; $hashtablermirror["R"]="I"
 $hashtablermirror["s"]="h"; $hashtablermirror["S"]="H"
 $hashtablermirror["t"]="g"; $hashtablermirror["T"]="G"
 $hashtablermirror["u"]="f"; $hashtablermirror["U"]="F"
 $hashtablermirror["v"]="e"; $hashtablermirror["V"]="E"
 $hashtablermirror["w"]="d"; $hashtablermirror["W"]="D"
 $hashtablermirror["x"]="c"; $hashtablermirror["X"]="C"
 $hashtablermirror["y"]="b"; $hashtablermirror["Y"]="B"
 $hashtablermirror["z"]="a"; $hashtablermirror["Z"]="A"
 $hashtablerrot13 = Hash.new  # http://en.wikipedia.org/wiki/ROT13
 $hashtablerrot13["a"]="n"; $hashtablerrot13["A"]="N"
 $hashtablerrot13["b"]="o"; $hashtablerrot13["B"]="O"
 $hashtablerrot13["c"]="p"; $hashtablerrot13["C"]="P"
 $hashtablerrot13["d"]="q"; $hashtablerrot13["D"]="Q"
 $hashtablerrot13["e"]="r"; $hashtablerrot13["E"]="R"
 $hashtablerrot13["f"]="s"; $hashtablerrot13["F"]="S"
 $hashtablerrot13["g"]="t"; $hashtablerrot13["G"]="T"
 $hashtablerrot13["h"]="u"; $hashtablerrot13["H"]="U"
 $hashtablerrot13["i"]="v"; $hashtablerrot13["I"]="V"
 $hashtablerrot13["j"]="w"; $hashtablerrot13["J"]="W"
 $hashtablerrot13["k"]="x"; $hashtablerrot13["K"]="X"
 $hashtablerrot13["l"]="y"; $hashtablerrot13["L"]="Y"
 $hashtablerrot13["m"]="z"; $hashtablerrot13["M"]="Z"
 $hashtablerrot13["n"]="a"; $hashtablerrot13["N"]="A"
 $hashtablerrot13["o"]="b"; $hashtablerrot13["O"]="B"
 $hashtablerrot13["p"]="c"; $hashtablerrot13["P"]="C"
 $hashtablerrot13["q"]="d"; $hashtablerrot13["Q"]="D"
 $hashtablerrot13["r"]="e"; $hashtablerrot13["R"]="E"
 $hashtablerrot13["s"]="f"; $hashtablerrot13["S"]="F"
 $hashtablerrot13["t"]="g"; $hashtablerrot13["T"]="G"
 $hashtablerrot13["u"]="h"; $hashtablerrot13["U"]="H"
 $hashtablerrot13["v"]="i"; $hashtablerrot13["V"]="I"
 $hashtablerrot13["w"]="j"; $hashtablerrot13["W"]="J"
 $hashtablerrot13["x"]="k"; $hashtablerrot13["X"]="K"
 $hashtablerrot13["y"]="l"; $hashtablerrot13["Y"]="L"
 $hashtablerrot13["z"]="m"; $hashtablerrot13["Z"]="M"
 $hashtablerrot18 = Hash.new  # http://netzreport.googlepages.com/online_converter_for_rot_5_13_18_47.html
 $hashtablerrot18["a"]="n"; $hashtablerrot18["A"]="N"
 $hashtablerrot18["b"]="o"; $hashtablerrot18["B"]="O"
 $hashtablerrot18["c"]="p"; $hashtablerrot18["C"]="P"
 $hashtablerrot18["d"]="q"; $hashtablerrot18["D"]="Q"
 $hashtablerrot18["e"]="r"; $hashtablerrot18["E"]="R"
 $hashtablerrot18["f"]="s"; $hashtablerrot18["F"]="S"
 $hashtablerrot18["g"]="t"; $hashtablerrot18["G"]="T"
 $hashtablerrot18["h"]="u"; $hashtablerrot18["H"]="U"
 $hashtablerrot18["i"]="v"; $hashtablerrot18["I"]="V"
 $hashtablerrot18["j"]="w"; $hashtablerrot18["J"]="W"
 $hashtablerrot18["k"]="x"; $hashtablerrot18["K"]="X"
 $hashtablerrot18["l"]="y"; $hashtablerrot18["L"]="Y"
 $hashtablerrot18["m"]="z"; $hashtablerrot18["M"]="Z"
 $hashtablerrot18["n"]="a"; $hashtablerrot18["N"]="A"
 $hashtablerrot18["o"]="b"; $hashtablerrot18["O"]="B"
 $hashtablerrot18["p"]="c"; $hashtablerrot18["P"]="C"
 $hashtablerrot18["q"]="d"; $hashtablerrot18["Q"]="D"
 $hashtablerrot18["r"]="e"; $hashtablerrot18["R"]="E"
 $hashtablerrot18["s"]="f"; $hashtablerrot18["S"]="F"
 $hashtablerrot18["t"]="g"; $hashtablerrot18["T"]="G"
 $hashtablerrot18["u"]="h"; $hashtablerrot18["U"]="H"
 $hashtablerrot18["v"]="i"; $hashtablerrot18["V"]="I"
 $hashtablerrot18["w"]="j"; $hashtablerrot18["W"]="J"
 $hashtablerrot18["x"]="k"; $hashtablerrot18["X"]="K"
 $hashtablerrot18["y"]="l"; $hashtablerrot18["Y"]="L"
 $hashtablerrot18["z"]="m"; $hashtablerrot18["Z"]="M"
 $hashtablerrot18["0"]="5"; $hashtablerrot18["5"]="0"; 
 $hashtablerrot18["1"]="6"; $hashtablerrot18["6"]="1";
 $hashtablerrot18["2"]="7"; $hashtablerrot18["7"]="2";
 $hashtablerrot18["3"]="8"; $hashtablerrot18["8"]="3";
 $hashtablerrot18["4"]="9"; $hashtablerrot18["9"]="4";

  # Methoden #########################

  def Say(*args)
    if ($globals['debug'].to_i==0) then return # Debugging ist aus -> raus hier
	else
		OSX::NSLog(*args)
	#	for index in (0...args.size)
	#		NSLog(args[index])
	#	end
	end # else !debug
  end # Say
  
  # AwakeFromNib
  def awakeFromNib
	Say("Awaking from nib.")
 
	# Window config
	@window.setFrameAutosaveName("Monoalphabetic Substitution Code Converter Window")
 
	# Popup config
	@encodingPopupbutton.removeAllItems
	@encodingPopupbutton.addItemWithTitle("ROT13")
	@encodingPopupbutton.addItemWithTitle("ROT18")
 	@encodingPopupbutton.addItemWithTitle("MIRROR")
#	@encodingPopupbutton.addItemWithTitle("ROT-RANDOM")

	# Preferences lesen
	preferencesRead()
	
	# Preferences in window anzeigen
	preferencesApply()
 
  end # of awakeFromNib

  # Darf der Text geaendert werden?
  # Ja --> Die Aenderung in dem uebersetzen Feld zeigen
  def textView_shouldChangeTextInRange_replacementString(textview, range, replacement)
	Say("textView_shouldChangeTextInRange_replacementString")
	
	  # Den geänderten Text zusammenstellen anhand Replacement string
	  @s = NSMutableString.alloc.initWithString(@upperTextfield.string)
	  @s.replaceCharactersInRange_withString(range, replacement)
	  Say("s: %@", @s)
	  
	  # Iterating over the source text
	  # http://ruby.activeventure.com/tutorial/part_02/while.html
	  # http://billsix.blogspot.com/2007/11/iteration-over-strings-in-ruby.html
	  ss=@s.to_s
	  i=0
      @lowerTextfield.setEditable_:true # Klappt!
      @lowerTextfield.selectAll_:self	# Nextes Insert ersetzt alten Text
	  while (i < ss.length)
		Say("i: %d", i)
		c=ss[i,1] # Das sliced :)
		Say("c: %s", c)
		 
		  # Popup-State entsprechend den hashtable auswählen
		  if (@encodingPopupbutton.titleOfSelectedItem == "ROT13") then
			 d=$hashtablerrot13[c]
		  else 
			if (@encodingPopupbutton.titleOfSelectedItem == "ROT18") then
			   d=$hashtablerrot18[c]
			else 
				if (@encodingPopupbutton.titleOfSelectedItem == "MIRROR") then
				   d=$hashtablermirror[c]
				else 
					if (@encodingPopupbutton.titleOfSelectedItem == "ROT-RANDOM") then
						Say("Not implemented yet!")
					else
						Say("Unknown encoding!")
					end
				end
			end
		  end

		# Ausgeben in unteres Textfield
	    if d==nil then 
	      d=c # Falls das Zeichen nicht übersetzt wird, einfach das urspr. Zeichen nehmen
	    end
	    Say("d: %s", d)
        @lowerTextfield.insertText_(NSString.alloc.initWithCString_encoding_(d, NSASCIIStringEncoding))
		
		# Next please!
		i=i.next
	  end  # while
      @lowerTextfield.setEditable_:false # Buggt!!
	
	# Ja, fuehre Aenderung durch
	return(true)
  end

  # Preferences lesen
  def preferencesRead()
    # Preferences laden, ggf. auf Default setzen
    # Oberes Textfeld
	$globals["lastText"] = OSX::NSUserDefaults.standardUserDefaults.objectForKey("lastText")
	if $globals['lastText'] == nil then
		$globals['lastText'] = ""
	end
	# Popup Button
	$globals["encodingPopupbuttonSetting"] = OSX::NSUserDefaults.standardUserDefaults.objectForKey("encodingPopupbuttonSetting")
	if $globals['encodingPopupbuttonSetting'] == nil then
		$globals['encodingPopupbuttonSetting'] = "ROT13"
	end
  end # preferencesRead

  # Preferences in window anwenden
  def preferencesApply()
	# Oberes Textfeld
	@upperTextfield.selectAll_:self	
	@upperTextfield.insertText_($globals["lastText"])
	# Popup Button
	popupSelectionString=NSString.alloc.initWithCString_encoding_($globals['encodingPopupbuttonSetting'], NSASCIIStringEncoding)
	@encodingPopupbutton.selectItemWithTitle_(popupSelectionString)
  end # preferencesApply

  # Preferences speichern
  def preferencesWrite()
	defaults = OSX::NSUserDefaults.standardUserDefaults
		# Oberes Textfeld sichern
		$globals["lastText"]=@upperTextfield.string
		Say("lasttext: %@", $globals["lastText"])
		defaults.setObject_forKey($globals["lastText"], 'lastText')
		# Popup setting sichern
		$globals["encodingPopupbuttonSetting"]=@encodingPopupbutton.titleOfSelectedItem
		defaults.setObject_forKey($globals["encodingPopupbuttonSetting"], 'encodingPopupbuttonSetting')
    defaults.synchronize
  end # preferencesWrite

 # About Window
  def aboutApp (sender)
    thisBundle = OSX::NSBundle.mainBundle
	copyrightString = thisBundle.objectForInfoDictionaryKey("CFBundleGetInfoString")
	versionString   = thisBundle.objectForInfoDictionaryKey("VersionString")
	NSApp.orderFrontStandardAboutPanelWithOptions("Copyright" => copyrightString, "ApplicationVersion" => versionString)
    # NSApp.orderFrontStandardAboutPanelWithOptions("Copyright" => "RubyCocoa #{RUBYCOCOA_VERSION}", "ApplicationVersion" => "Ruby #{VERSION}")
  end # aboutApp 
  ib_action :aboutApp

 def applicationDidFinishLaunching(notification)
        Say("Application finished launching")
 end
	  
 # Will Terminate
 def applicationWillTerminate (notification)
	Say("Will terminate.")
 end
 
 # Should Terminate
 def encodingPopupbuttonClicked (sender)
	Say("encodingPopupbuttonClicked.")
    # Wenn das angeklicked wurde -> Text neu umrechnen!
	emptyString=NSString.alloc.initWithCString_encoding_("", NSASCIIStringEncoding)
	textView_shouldChangeTextInRange_replacementString(@upperTextfield, NSMakeRange(0,0), emptyString)
 end
 ib_action :encodingPopupbuttonClicked


 # Popup clicked
 def applicationShouldTerminate (notification)
	Say("Should terminate.")
	preferencesWrite
 end


end # AppController
